import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.util.List;
/**
 * Write a description of class Buton here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Buton extends Utilitati
{
    /**
     * Act - do whatever the Buton wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private World link;//link pentru lume
    private GreenfootSound sound;//sunet pt buton
    private GreenfootImage image1,image2;//poza pt hover la buton
    private boolean merge=true;//daca sunetul are play
    private int tipButon,pozaAct=0;//tipul butonului
    private ArrayList<GreenfootImage> poze;//lista pt imaginile de pe fundal
    
    private void memoryClear(){
        List actori = getWorld().getObjects(Actor.class);
        for(int i=0; i<actori.size(); i++)
        {
            if(actori.get(i)!=this)
            {
                getWorld().removeObject((Actor)actori.get(i));
            }
            
        }
        getWorld().setBackground(new GreenfootImage("FUNDALreguli.png"));
    }
    
    public Buton (String image, World link){
        setImage(new GreenfootImage(image));//setez imaginea butonului
        //this.image=new GreenfootImage(image);
        this.link=link;//setez linkul pt lume
        this.tipButon=1;//tipul butonului
    }
    public Buton(GreenfootSound sound)
    {
        setImage("muzicada.png");//setez imaginea butonului
        this.sound=sound;//sunetul ce trebuie redat
        this.tipButon=2;//tipul butonului
    }
    public Buton(ArrayList<GreenfootImage> poze, World link)
    {
        setImage("ButonOk.png");//imaginea butonului
        this.poze=poze;//lista cu poze
        this.tipButon=3;//tipul butonului
        this.pozaAct=0;//poza ce trebuie redata
        this.link=link;//linkul lumii
    }
    
    
    public Buton(String image1,String image2)
    {
        setImage(image1);//setez imaginea butonului
        this.image1=new GreenfootImage(image1);
        this.image2=new GreenfootImage(image2);
        this.tipButon=4;//tipul butonului
    }
    public Buton (String image1,String image2, World link){
        setImage(new GreenfootImage(image1));//setez imaginea butonului
        //this.image=new GreenfootImage(image);
        this.image1=new GreenfootImage(image1);
        this.image2=new GreenfootImage(image2);
        this.link=link;//setez linkul pt lume
        this.tipButon=5;//tipul butonului
    }
    
    
    
    public void act() 
    {
        // Add your action code here.
        
        switch(tipButon){
        case(1):{
            //daca e de tipul 1
            /*if (Greenfoot.mouseMoved(this))
            {
                setImage(image);
                
            }
            if (Greenfoot.mouseMoved(null) && !Greenfoot.mouseMoved(this))
            {
                setImage(image);
            }*/
            if(Greenfoot.mouseClicked(this))
            {
                if(!(getWorld() instanceof Pauza)){}
                memoryClear();
                GreenfootSound sunet=new GreenfootSound("click.mp3");
                sunet.play();
                if(getWorld() instanceof IntroducereQuierres)
                {
                    IntroducereQuierres.sunet.stop();
                }
                else if(getWorld() instanceof MeniuPrincipal)
                {
                    StartScreen.sunet.stop();
                }
                else if(getWorld() instanceof Credite)
                {
                    StartScreen.sunet.stop();
                }
                Greenfoot.setWorld(this.link);//merg la lumea ceruta
                getWorld().removeObject(this);
                return;
                
            }
            break;
        }
        case(2):{
            if(Greenfoot.mouseClicked(this))
            {
                
                if(merge==true)
                {
                    setImage("muzicanu.png");//opresc muzica
                }
                else
                {
                    setImage("muzicada.png");//pornesc muzica
                }
                merge=!merge;//schimb starea 
            }
            if(merge==true){
             sound.play();//dau play la sunet
            }
            else if(merge==false){
            sound.stop();//opresc sunetul
            }
            break;
        }
        case(3):{
           if(pozaAct<poze.size())
           {
              getWorld().setBackground(poze.get(pozaAct));//setez poza asta ca fundal
              if(Greenfoot.mouseClicked(this))
              {
                  
                  pozaAct++;//schimb poza
              }
           }
           else
           {
            //am terminat slideurile
            if(Greenfoot.mouseClicked(this))
            {
                memoryClear();
                GreenfootSound sunet=new GreenfootSound("click.mp3");
                sunet.play();
                if(getWorld() instanceof IntroducereQuierres2)
                {
                    IntroducereQuierres2.sunet.stop();
                }
                Greenfoot.setWorld(this.link);//merg pe link
                getWorld().removeObject(this);
                return;
            }
           }
           break;   
        }
        case(4):{
            //tipul 4- pentru terminarea programului
            if (Greenfoot.mouseMoved(this))
            {
                setImage(image2);//cand sunt pe buton
                
            }
            if (Greenfoot.mouseMoved(null) && !Greenfoot.mouseMoved(this))
            {
                setImage(image1);//altfel
            }
            
            
             if(Greenfoot.mouseClicked(this))
            {
                Greenfoot.stop();
                //System.exit(0);//ies din lume
            }
            break;
        }
        case(5):{
              //daca e de tipul 5
            if (Greenfoot.mouseMoved(this))
            {
                setImage(image2);//cand sunt pe buton
                
            }
            if (Greenfoot.mouseMoved(null) && !Greenfoot.mouseMoved(this))
            {
                setImage(image1);//altfel
            }
            
            if(Greenfoot.mouseClicked(this))
            {
                memoryClear();
                GreenfootSound sunet=new GreenfootSound("click.mp3");
                sunet.play();
                if(getWorld() instanceof MeniuPrincipal)
                {
                    StartScreen.sunet.stop();
                }
                Greenfoot.setWorld(this.link);//merg la lumea ceruta
                getWorld().removeObject(this);
                return;
            }
        
              break;
        }
        
    }
        

    }    
}
