import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class EndlessSpace here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class EndlessSpace extends Niveluri
{

    /**
     * Constructor for objects of class EndlessSpace.
     * 
     */
    //ecranul de endless space
    
    private long startTime,timpCurent,nrAleator;//variabilele utilizate pt spawnul de obiecte
    public static long scor=0;//scorul jucatorului
    public static int vieti=3;//numarul de vieti al jucatorului
    private boolean amEvent=false;//variabila pentru evenmente aleatorii
    
    public EndlessSpace(){
        //initializarea lumii
        super(1200,600,1);
        prepare();
        /*GreenfootSound sunet= new GreenfootSound("nivel1.wav");
         Buton butonSunet=new Buton(sunet,2);
        addObject(butonSunet, 30, 570);*/
    }
    
    public void prepare()
    {
        startTime=System.currentTimeMillis();//setez variabila pt timpul in care mi-am creat lumea
        addObject(new NavaSpatiala(3), 180,300);//adaug nava spatiala cu viteza 4
        //actualizez variabilele pt jucator+timpul+evenimentul aleator
        this.scor=0;
        this.vieti=3;
        this.amEvent=false;
        this.startTime=0;
        this.timpCurent=0;
        /****/
    }
    
    //creez un gif pt background
    GifImage background=new GifImage("FUNDALnivel1.gif");
    public void act()
    { 
        
        //imi iau o cheie pt inputul jucatorului
        String key=Greenfoot.getKey();
        if (key != null && "p".equals(key)) {
            //daca jucatorul apasa pe tasta "p", merg in lumea de pauza din lumea asta
            Greenfoot.setWorld(new Pauza(this));
        }
        //actualizez fundalul cu fiecare frame din gif
        setBackground(background.getCurrentImage() );
        timpCurent++;//cresc timpul cu fiecare frame al lumii
        eventRand(timpCurent);//fac eveniment aleatoriu
        if((timpCurent-startTime)%15==0)
        {
            //la fiecare 100 de frame-uri ale lumii spawnez un asteroid care poate fi distrus
            addObject( new Destruct(),1150, Greenfoot.getRandomNumber(550));
        }
        
        //showText("timpCurent:"+timpCurent,600,60);
        showText("Asteroizi distrusi:"+scor,100,20);
        showText("Vieti ramase:"+vieti,100,40);
        showText("Apasa P pentru a opri jocul",1050,20);
        
    }
    
    private void eventRand(long timpCurent)
    {
        //showText("Am event:"+amEvent,600,20);
        //showText("Eveniment+nrAleator:"+(nrAleator+startTime),600,40);
        if(amEvent==false)
        {
            //daca nu am eveniment, creez unul care sa fie la 600 de frameuri distanta de precedentul
            nrAleator=timpCurent-startTime+Greenfoot.getRandomNumber(800)+600;
            amEvent=true;
        }
        else if(amEvent==true && timpCurent==startTime+nrAleator)
        {
            //am eveniment si acum e momentul cand ar trebui sa apara
            //imi spawnez asteroizi
            for(int y=50; y<=550; y+=60)
            {
                int caz=Greenfoot.getRandomNumber(8);//probabilitatea sa am un asteroid indestructibil
                if(caz==1)
                {
                    //este indestructibil
                    addObject( new Indestruct(),1150, y);
                }
                else{
                    //este normal
                    addObject( new Destruct(),1150, y);
                }
            }
            amEvent=false;//sterg evenimentul
        }
    }
}
