import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.io.File; 
import java.lang.Object.*;
/**
 * Write a description of class Nivel4_2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Nivel4_2 extends Nivel4
{

    /**
     * Constructor for objects of class Nivel4_2.
     * 
     */
    
    GifImage background=new GifImage("FUNDALnivel2_0.gif");
    
    public static final int[][] model={
        { -1,-1,  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,-1,-1, -1, -1, -1, -1, -1, -1 },
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1}, 
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,-1, -1, -1, -1, -1, -1 }
    };
    
    public static int inamici=4;
    private boolean amUsi=false;
    
    //health
    public HealthBar bara;
    private Color cS=new Color(6,197,204), cD=new Color(222,93,18);
    private boolean baraPusa=false;
    private boolean amMat=false;
    
    private void pregatescBara(){
        //health
        bara=new HealthBar(".","Viata",Astroneer.hp,Astroneer.hpMax);
        bara.setSafeColor(cS);
        bara.setDangerColor(cD);
        bara.setBarWidth(181);
        bara.setBarHeight(17);
        bara.setReferenceText("   ");
        addObject(new UI("health"),148,40);
        addObject(bara,173,40);
       
    }
    
    private void addUsa(){
        
        if(this.inamici==0 && amUsi==false){
             addObject(new Usa(new Nivel4_3(),true), 1200,285);
        amUsi=true;
        }
    
    }
    
    private void copMat(){
    
        for(int i=0; i<11; i++)
        {
          for(int j=0; j<23; j++){
            Npc.matElem[i][j]=model[i][j];
           }
        }
        amMat=true;
    
    }
    
    public void prepare(){
        //save
        File save=new File("save\\save.txt");
        ArrayList<String> sv=new ArrayList<String>();
        sv.add("Nivel4_2()");
        SaveSystem.SaveFile(save,sv);
        
        
        this.amMat=false;
        this.inamici=7;
        this.amUsi=false;
        
        
        addObject(new PereteInvizibil("W","mare"), 600,0);//
            addObject(new PereteInvizibil("A","mare90"),0,300);//margini
       addObject(new PereteInvizibil("S","mare"), 600,580);//
        
         addObject(new PereteInvizibil("D","mic90"),1185,0);//margini
        addObject(new PereteInvizibil("D","mic90"),1185,60);//margini
        addObject(new PereteInvizibil("D","mic90"),1185,120);//margini
        addObject(new PereteInvizibil("D","mic90"),1185,180);//margini
       
       addObject(new PereteInvizibil("W","mic"), 1200,210);
                
       
                
       addObject(new PereteInvizibil("S","mic"), 1200,390);
                
       addObject(new PereteInvizibil("D","mic90"),1185,420);//margini
       addObject(new PereteInvizibil("D","mic90"),1185,480);//margini
       addObject(new PereteInvizibil("D","mic90"),1185,540);//margini
       addObject(new PereteInvizibil("D","mic90"),1185,600);//margini
        
        
        
       
        addObject(new PereteSpate(new GifImage("peretePiatra.png")), 600,600);
        
       
        Player jucator=new Player();
        jucator.addItem("laser");
        jucator.addItem("sabie");
        addObject(jucator,720,300);
        
        
        
        
        
        addObject(new Goblin(), 100,100);
        addObject(new Goblin(), 300,100);
        addObject(new Goblin(), 500,100);
        addObject(new Goblin(), 700,100);
        addObject(new Goblin(), 900,100);
        addObject(new Droid("oy",50),1000,250);
        addObject(new Droid("ox",150),600,150);
        
    
        
        
        addObject(new PereteFata(new GifImage("peretePiatra.png")),600,555);
    
        this.baraPusa=false;
    
    }
    
    public Nivel4_2()
    {
        super(1200,600,1);
        prepare();
    }
    public void act(){
         if(amMat==false){
            copMat();
        }
     
        
         if(baraPusa==false)
        {
           baraPusa=true;
           pregatescBara();
        }
        setBackground( background.getCurrentImage() );
        String key=Greenfoot.getKey();
        if (key != null && "p".equals(key)) {
            Greenfoot.setWorld(new Pauza(this));//opresc jocul
        }
        addUsa();
        
    }

    
    
}
