import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.lang.Math; 
/**
 * Write a description of class Astroneer_full here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Astroneer
{
    /**
     * Act - do whatever the Astroneer_full wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    HashMap<String, GifImage> directie = new HashMap<String, GifImage>();
    GifImage playerImg=directie.get(super.gif);
    private long timpSab=0,timpLaser=0,timpBoaba=0,timpPumni=0;
    
    public Player(){
        //variabile initiale
        //super.inViata=true;
        //super.hp=400;
        //super.speed=5;
        
        //moarte
        directie.put("death",new GifImage("player_death.gif"));
        
        //merge
        directie.put("D",new GifImage("player_m_D.gif"));
        directie.put("W",new GifImage("player_m_W.gif"));
        directie.put("A",new GifImage("player_m_A.gif"));
        directie.put("S",new GifImage("player_m_S.gif"));
        
        //sta
        directie.put("idle", new GifImage("player_m_Idle.gif"));
        
        //se uita
        directie.put("right",new GifImage("vedere_D.gif"));
        directie.put("up",new GifImage("vedere_W.gif"));
        directie.put("left",new GifImage("vedere_A.gif"));
        directie.put("down",new GifImage("vedere_S.gif"));
        
       // HealthBar bara=new HealthBar("Jucator","Viata",this.hp, this.hp);
       // getWorld().addObject(bara,0,0);
        
        
        super.timpPrec=System.currentTimeMillis();
    }
    public void atingeNpc()
    {
       Actor a = getOneIntersectingObject(Npc.class);//daca sunt in exterior
       if(a!=null){
          //am un npc care mi se atinge cu playerul
          int npcX=(a.getX()-getX())*8/100;//8/100
          int npcY=(a.getY()-getY())*7/100;//7/100   
          
          setLocation(getX()-npcX, getY()-npcY);
       }
      
       Actor b=getOneObjectAtOffset(0,0,Npc.class);//daca sunt in interior
       if(b!=null){
            int npcX=(b.getX()-getX());//8/100
            int npcY=(b.getY()-getY());//7/100
              
            setLocation(getX()-npcX, getY()-npcY);
       }
    }
    
    public void move(){
        
        if(super.gif!="idle" && super.gif!="right" &&super.gif!="up" &&super.gif!="down" && super.gif!="left"){atingeNpc();}
        super.move();
        if(super.gif!="idle" && super.gif!="right" &&super.gif!="up" &&super.gif!="down" && super.gif!="left"){atingeNpc();}
        
        playerImg=directie.get(super.gif);
    }
    protected void vedere(){
        super.vedere();
        playerImg=directie.get(super.gif);
    }
    
    protected void lovit(){
        
         if(isTouching(SabieGoblin.class)){
            timpSab++;//cat timp ating ating playerul
            if(timpSab>=16)
            {
               super.health(SabieGoblin.damage);
              GreenfootSound sunet=new GreenfootSound("talkshitgetHIT.mp3");
              sunet.play();
               if(getWorld() instanceof Nivel2_0){
               Nivel2_0 lume=(Nivel2_0)getWorld();
               lume.bara.subtract(SabieGoblin.damage);
               }
               else if(getWorld() instanceof Nivel2_7){
               Nivel2_7 lume=(Nivel2_7)getWorld();
               lume.bara.subtract(SabieGoblin.damage);
              }
              else if(getWorld() instanceof Nivel3_1){
               Nivel3_1 lume=(Nivel3_1)getWorld();
               lume.bara.subtract(SabieGoblin.damage);
              }
              else if(getWorld() instanceof Nivel3_2){
               Nivel3_2 lume=(Nivel3_2)getWorld();
               lume.bara.subtract(SabieGoblin.damage);
              }
              else if(getWorld() instanceof Nivel3_3){
               Nivel3_3 lume=(Nivel3_3)getWorld();
               lume.bara.subtract(SabieGoblin.damage);
              } 
              else if(getWorld() instanceof Nivel3_4){
               Nivel3_4 lume=(Nivel3_4)getWorld();
               lume.bara.subtract(SabieGoblin.damage);
              } 
              else if(getWorld() instanceof Nivel4_2){
               Nivel4_2 lume=(Nivel4_2)getWorld();
               lume.bara.subtract(SabieGoblin.damage);
              } 
               
               timpSab=0;
            }
            
        }
        else if(timpSab>0)
        {
            timpSab--;//modific timpul daca nu 
        }
        
        
         if(isTouching(LaserDroid.class)){
            timpLaser++;//cat timp ating ating playerul
            if(timpLaser>=16)
            {
               super.health(LaserDroid.damage);
              GreenfootSound sunet=new GreenfootSound("talkshitgetHIT.mp3");
              sunet.play();
               if(getWorld() instanceof Nivel2_0){
               
               Nivel2_0 lume=(Nivel2_0)getWorld();
               lume.bara.subtract(LaserDroid.damage);
            }
            else if (getWorld() instanceof Nivel2_4){
                
               Nivel2_4 lume=(Nivel2_4)getWorld();
               lume.bara.subtract(LaserDroid.damage);
               
            }
            else if (getWorld() instanceof Nivel2_5){
                
               Nivel2_5 lume=(Nivel2_5)getWorld();
               lume.bara.subtract(LaserDroid.damage);
               
            }
            else if (getWorld() instanceof Nivel4_2){
                
               Nivel4_2 lume=(Nivel4_2)getWorld();
               lume.bara.subtract(LaserDroid.damage);
               
            }
            else if(getWorld() instanceof BossFight){
               BossFight lume=(BossFight)getWorld();
               lume.bara.subtract(LaserDroid.damage);
            }
               timpLaser=0;
               removeTouching(LaserDroid.class);
            }
            
        }
        
        else if(timpLaser>0)
        {
            timpLaser--;//modific timpul daca nu 
        }
        if(isTouching(Boaba.class)
        ){
            timpBoaba++;//cat timp ating ating playerul 
            if(getWorld() instanceof Nivel2_6){
               
               Nivel2_6 lume=(Nivel2_6)getWorld();
               lume.bara.setValue(400);
               super.health(-(lume.bara.getMaximumValue()-Astroneer.hp));
               
               lume.inamici--;
            }
            else if(getWorld() instanceof Nivel4_1)
            {
               Nivel4_1 lume=(Nivel4_1)getWorld();
               lume.bara.setValue(400);
               super.health(-(lume.bara.getMaximumValue()-Astroneer.hp));
               
               lume.inamici--;
            }
            else if(getWorld() instanceof Nivel4_3)
            {
               Nivel4_3 lume=(Nivel4_3)getWorld();
               lume.bara.setValue(400);
               super.health(-(lume.bara.getMaximumValue()-Astroneer.hp));
               
            }
            else if(getWorld() instanceof BossFight)
            {
               BossFight lume=(BossFight)getWorld();
               lume.bara.setValue(400);
               super.health(-(lume.bara.getMaximumValue()-Astroneer.hp));
               
            }
            if(timpBoaba>=16)
            {
               
               removeTouching(Boaba.class);
         }
        }
        if(isTouching(PumniQuierres.class)){
            timpPumni++;//cat timp ating ating playerul
            
            
            
            if(timpPumni>=16)
            {
            GreenfootSound sunet=new GreenfootSound("talkshitgetHIT.mp3");
            sunet.play();   
            super.health(PumniQuierres.damage);
            if(getWorld() instanceof BossFight){
               BossFight lume=(BossFight)getWorld();
               lume.bara.subtract(PumniQuierres.damage);
            }
            else  if(getWorld() instanceof Nivel2_0){
               Nivel2_0 lume=(Nivel2_0)getWorld();
               lume.bara.subtract(PumniQuierres.damage);
            }
              
               timpPumni=0;
              
            }
            
        }
        else if(timpPumni>0)
        {
            timpPumni--;//modific timpul daca nu 
        }
        
        
    
}
    private long timpMort=0;
    private void arataHp(){
    if(Greenfoot.isKeyDown("enter")){
                System.out.println("#####"+"######");
                System.out.println( Astroneer.hp);
                System.out.println("#####"+"######");
    }
    }
        
    public void act() 
    {
        // Add your action code here.
       lovit();
       arataHp();
        if(inViata==false){ 
            if(timpMort>=55)
            {
                inViata=true;
                Greenfoot.setWorld(new Pierdere(2));
                
            }
            playerImg=directie.get("death");
            timpMort++;
            Astroneer.hp=Astroneer.hpMax; //actualizam healthBar
            
         
        }
        else {
            vedere();
            move();
        }
        setImage(playerImg.getCurrentImage());
        
       
        
        
    }    
}
