import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Bolt here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bolt extends Nava
{
    /**
     * Act - do whatever the Bolt wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    //gifurile pt bolt
    GifImage bolt=new GifImage("laser(1).gif"); 
    GifImage exp=new GifImage("expAst.gif");
    
    private boolean disparut= false;//exista in lume
    private long timp=0;//timpul pt explozie
    private boolean explodat=false;//e explodat
    
    public Bolt(){
        //fac scale pt bolt pt ca am poza prea mare
        int scalePercent=80;
        for(GreenfootImage image: bolt.getImages())
        {
        int wide = image.getWidth()*scalePercent/100;
        int high = image.getHeight()*scalePercent/100;
        image.scale(wide, high);
        }
        GreenfootSound sunet=new GreenfootSound("shootshoot.mp3");
        sunet.play();
    }
    
    public void act() 
    {
           if(disparut==false && explodat==false)
           {
               setImage(bolt.getCurrentImage());
               setLocation(getX()+6,getY());
               atins();
               if(disparut==true){return;}
               margine();
           }
           else if(explodat==true)
           {
               setImage(exp.getCurrentImage());
               timp++;
               if(timp>=10)
               {
                   getWorld().removeObject(this);
                   return;
               }
           }
           
    }
   
    private void margine(){
        //elimin daca mi-a iesit din lume
        if(getX()>=1180)
        {
            getWorld().removeObject(this);
            disparut=true;
        }
    }
    private void atins(){
        /*Actor a = getOneIntersectingObject(Asteroid.class); 
        if(a !=null)
        {
           getWorld().removeObject(a);   
           getWorld().removeObject(this);
           disparut=true;
        }*/
        
        //verific daca lovesc un asteroid
        //!hit detectionul nu e 100% corect din cauza ca asteroizii au forma circulara 
        if(isTouching(Destruct.class)){
            timp++;//cat timp ating ating asteroidul
            if(timp>=8 && getWorld() instanceof Nivel1)
            {
            //modific scorul, timpul de atingere si starea boltului    
            Nivel1.scor++;
            removeTouching(Asteroid.class);//sterg asteroidul
            explodat=true;
            timp=0;
            }
            else if(timp>=8 && getWorld() instanceof EndlessSpace)
            {
            //modific scorul si celelalte valori
            EndlessSpace.scor++;
            removeTouching(Asteroid.class);
            explodat=true;
            timp=0;
            }
            else if(timp>=8 && getWorld() instanceof Reguli1)
            {
               removeTouching(Asteroid.class);
               explodat=true;
               timp=0;
            }
        }
        else if(timp>0)
        {
            timp--;//modific timpul daca nu 0 si nu mai ating asteroidul
        }
        
        
        if(isTouching(Indestruct.class)){
            //nu poate fi distrus asteroidul
            getWorld().removeObject(this);
            disparut=true;
        }
       
    }
      
}