import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class BossFight here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BossFight extends Niveluri
{

    public static final int[][] model={
        { -1,-1,  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,-1,-1, -1, -1, -1, -1, -1, -1 },
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1}, 
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, -1},
        { -1,-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,-1, -1, -1, -1, -1, -1 }
    };
    
     //health
    public HealthBar bara,baraQuierres;
    private Color cS=new Color(6,197,204), cD=new Color(222,93,18), cSQ=new Color(255,201,14);
    private boolean baraPusa=false,amMat=false;
    
    GifImage background=new GifImage("FUNDALnivel2_0.gif");
    private void pregatescBara(){
        //health
        bara=new HealthBar(".","Viata",Astroneer.hp,Astroneer.hpMax);
        bara.setSafeColor(cS);
        bara.setDangerColor(cD);
        bara.setBarWidth(181);
        bara.setBarHeight(17);
        bara.setReferenceText("   ");
        addObject(new UI("health"),148,40);
        addObject(bara,173,40);
        //health
        
        
        
         //health
        baraQuierres=new HealthBar(".","Viata",Quierres.hpMax,Quierres.hpMax);
        baraQuierres.setSafeColor(cSQ);
        baraQuierres.setDangerColor(new Color(250,0,0));
        baraQuierres.setBarWidth(800);
        baraQuierres.setBarHeight(8);
        baraQuierres.setReferenceText("   ");
        addObject(new UI("healthQuierres"),572,539);
        addObject(baraQuierres,600,540);
        //showText(Astroneer.hp+" ",600,400);
        //health
    }
    
     private void copMat(){
    
        for(int i=0; i<11; i++)
        {
          for(int j=0; j<23; j++){
            Npc.matElem[i][j]=model[i][j];
           }
        }
        amMat=true;
    
    }
    private void prepare(){
       addObject(new PereteSpate(new GifImage("peretePiatra.png")), 600,600);
        
       addObject(new PereteInvizibil("W","mare"), 600,0);//
       addObject(new PereteInvizibil("D","mare90"),1200,300);//margini
       addObject(new PereteInvizibil("A","mare90"),0,300);//margini
       addObject(new PereteInvizibil("S","mare"), 600,580);//
       
       Player jucator=new Player();
       addObject(jucator,720,300);
       jucator.addItem("laser");
       jucator.addItem("sabie");
        
       
       addObject(new Quierres(),1100,300);
       addObject(new PereteFata(new GifImage("peretePiatra.png")),600,555);
       
       GreenfootSound sunet=new GreenfootSound("bosstheme.wav");
       sunet.setVolume(60);
       Buton butonSunet=new Buton(sunet);
       addObject(butonSunet, 30, 570);
       
       this.baraPusa=false;
    }
    
    public BossFight()
    {
        super(1200,600,1);
        prepare();
    }
    
    public void act(){
        if(amMat==false){
            copMat();
        }
         if(baraPusa==false)
        {
           baraPusa=true;
           pregatescBara();
        }
        setBackground( background.getCurrentImage() );
        String key=Greenfoot.getKey();
        if (key != null && "p".equals(key)) {
            Greenfoot.setWorld(new Pauza(this));//opresc jocul
        }
        
    }
    
}
