import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.io.File;
import java.util.List;
/**
 * Write a description of class NavaSpatiala here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class NavaSpatiala extends Nava
{
    

    protected int poz;//variabila cu care se misca nava
    private long timpPrec;
    private long timp=0;
    
    private boolean inViata=true,castigat=false;
    
    GifImage nava=new GifImage("nava.gif");
    GifImage explozie=new GifImage("navaMoarte.gif");
    
    public NavaSpatiala(int poz){
        //setez nava si ii fac scale-ul
        this.poz=poz;
        timpPrec=System.currentTimeMillis();
        int scalePercent=80;
        for(GreenfootImage image: nava.getImages())
        {
        int wide = image.getWidth()*scalePercent/100;
        int high = image.getHeight()*scalePercent/100;
        image.scale(wide, high);
        }
    }
    private void memoryClear(){
        List actori = getWorld().getObjects(Actor.class);
        for(int i=0; i<actori.size(); i++)
        {
            if(actori.get(i)!=this)
            {
                getWorld().removeObject((Actor)actori.get(i));
            }
            
        }
    }
     
    public void act() 
    {
        if(inViata==true)
        {
            if(castigat==false)
            {
                misca();//ma misc
                lovitAsteroid();//verific daca lovesc asteroid
            }
            
            setImage(nava.getCurrentImage() );
            
            long delay=0;
            if(getWorld() instanceof Nivel1 && Nivel1.scor>=50)
            {
                //ai castigat
                //urmeaza animatia de tranzitie in niv urmator
                inViata=true;
                castigat=true;
                if(getY()>300){
                    setLocation(getX(),getY()-poz);
                }
                else if(getY()<300){
                    setLocation(getX(),getY()+poz);
                }
                if(getX()>300){
                    setLocation(getX()-(poz/2+1),getY());
                }
                else if(getX()<300){
                    setLocation(getX()+(poz/2+1),getY());
                }
                else if(getY()==300 && getX()==300){
                    //getWorld().removeObjects(getWorld().getObjects(Asteroid.class));
                    //salvez jocul
                    File save=new File("save\\save.txt");
                    ArrayList<String> sv=new ArrayList<String>();
                    sv.add("IntroducerePlaneta()");
                    
                    SaveSystem.SaveFile(save,sv);
                    memoryClear();
                    Greenfoot.setWorld(new IntroducerePlaneta());//merg in animatie
                    getWorld().removeObject(this);
                    return;
                }
            }
        }
        else if(inViata==false)
        {
            //ai murit
            setImage(explozie.getCurrentImage() );//schimb imaginea navei
            timp++;//timpul ca sa ruleze giful navei distruse
            if(timp==15)
            {
                //am trecut prin tot ciclul animatiei
                //getWorld().removeObjects(getWorld().getObjects(Asteroid.class));
                if(getWorld() instanceof Nivel1)
                {
                   Greenfoot.setWorld(new Pierdere(1));
                }
                else if(getWorld() instanceof EndlessSpace)
                {
                    Greenfoot.setWorld(new Pierdere(0));
                }
                
            }
        }
    }
    
     protected void misca()
    {
        lovitAsteroid();
       if(Greenfoot.isKeyDown("w") || Greenfoot.isKeyDown("up") )
       {
         //merge in nord
         setLocation(getX(),getY()-poz);
       }
       if(Greenfoot.isKeyDown("s") || Greenfoot.isKeyDown("down") )
       {
         //merge in sud
         setLocation(getX(),getY()+poz);
       }
       if(Greenfoot.isKeyDown("a") ||  Greenfoot.isKeyDown("left"))
       {
         //merge in vest
         setLocation(getX()-(poz/2+1),getY());
       }
       if(Greenfoot.isKeyDown("d") || Greenfoot.isKeyDown("right"))
       {
         //merge in est
         setLocation(getX()+(poz/2+1),getY());
       }
       
       if(Greenfoot.isKeyDown("space"))
       {
           //pt spawnarea boltului
           long timpCurent=System.currentTimeMillis(); 
           if(timpCurent-timpPrec>=650){
              //spawnez boltul daca a trecut un anumit timp de la boltul precedent 
              laser();
              timpPrec=timpCurent;
            }
       }
    }
    
    
    private void laser(){
       Bolt proiectil=new Bolt();
       getWorld().addObject(proiectil, getX()+60,getY());
    }
    
    private void lovitAsteroid()
    {
        Actor a = getOneIntersectingObject(Asteroid.class);
        if(a != null){
            //daca ating un asteroid scad numarul de vieti din nivel
            //sterg asteroidul si schimb starea navei daca nu mai am vieti
            if(getWorld() instanceof Nivel1)
            {
              timp++;
              if(timp>=10)
              {
              GreenfootSound sunet=new GreenfootSound("talkshitgetHIT.mp3");
              sunet.play();
              Nivel1.vieti--;
              getWorld().removeObject(a);
              timp=0;
              if(Nivel1.vieti==0)
              {
                  inViata=false;
              }
            //getWorld().removeObject(this);
               }    
            }
            else if(getWorld() instanceof EndlessSpace)
            {
              timp++;
              if(timp>=10)
              {
                  GreenfootSound sunet=new GreenfootSound("talkshitgetHIT.mp3");
                  sunet.play();
                  EndlessSpace.vieti--;
                  getWorld().removeObject(a);
                  timp=0;
                  if(EndlessSpace.vieti==0)
                  {
                  inViata=false;
                  }
              //getWorld().removeObject(this);
              }  
            }
        }
        else if(timp>0)
        {
            timp--;
        }
    }
}