import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.io.File; 
import java.lang.Object.*;
/**
 * Write a description of class Nivel3_1 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Nivel3_4 extends Nivel3
{

    /**
     * Constructor for objects of class Nivel3_1.
     * 
     */
    GifImage background=new GifImage("FUNDALnivel3_4.png");
    
    private static final int[][] model={
        { -1,-1,  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,-1,-1, -1, -1, -1, -1, -1, -1 },
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1},
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1},
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1},
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1},
        
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   -1, -1, -1, -1, -1,   0, 0, 0, -1},
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,   -1, -1, -1, -1, -1,   0, 0, 0, -1},
        
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1}, 
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1},
        { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1},
        { -1,-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,-1, -1, -1, -1, -1, -1 }
    };
    
    
    public static int inamici=4;
    private boolean amUsi=false;
    //health
    public HealthBar bara;
    private Color cS=new Color(6,197,204), cD=new Color(222,93,18);
    private boolean baraPusa=false;
    private boolean amMat=false;
    private void pregatescBara(){
        //health
        bara=new HealthBar(".","Viata",Astroneer.hp,Astroneer.hpMax);
        bara.setSafeColor(cS);
        bara.setDangerColor(cD);
        bara.setBarWidth(181);
        bara.setBarHeight(17);
        bara.setReferenceText("   ");
        addObject(new UI("health"),148,40);
        addObject(bara,173,40);
        //showText(Astroneer.hp+" ",600,400);
        //health
    }
    
     private void addUsa(){
        
        if(this.inamici==0 && amUsi==false){
             addObject(new Usa(new Nivel4_1(),true), 1122,100);
        
        amUsi=true;
        }
    
    }
    
    private void copMat(){
    
        for(int i=0; i<11; i++)
        {
          for(int j=0; j<23; j++){
            Npc.matElem[i][j]=model[i][j];
           }
        }
        amMat=true;
    
    }
    
    private void prepare(){
       
        File save=new File("save\\save.txt");
        ArrayList<String> sv=new ArrayList<String>();
        sv.add("Nivel3_4()");
        SaveSystem.SaveFile(save,sv);
        
        
        this.amMat=false;
        this.inamici=4;
        this.amUsi=false;
        super.amGoblini=false;
        
        

        addObject(new PereteInvizibil("W","mare"), 600,0);
        addObject(new PereteInvizibil("S","mare"), 600,585);
        addObject(new PereteInvizibil("D","mare90"),1195,300);//margini
        addObject(new PereteInvizibil("D","mic90"),1040,69);//margini
        addObject(new PereteInvizibil("D","mic90"),1040,128);//margini
        
        addObject(new PereteInvizibil("D","mic90"),825,326);
        addObject(new PereteInvizibil("A","mic90"),1008,326);
                    addObject(new PereteInvizibil("W","mic"),855,360);
                    addObject(new PereteInvizibil("W","mic"),973,360);
                    addObject(new PereteInvizibil("W","mic"),914,360);
                    addObject(new PereteInvizibil("S","mic"),973,295);
                    addObject(new PereteInvizibil("S","mic"),855,295);
                    addObject(new PereteInvizibil("S","mic"),914,295);
        
        
    
        addObject(new PereteInterior(new GifImage("piatra1.png")), 919,320);
        
        Player jucator=new Player();
        jucator.addItem("laser");
       addObject(jucator,150,300);
       
       
       addObject(new PereteFata(new GifImage("pereteMunte3.png")),600,523);
       addObject(new PereteInterior(new GifImage("piatra1_sus.png")), 919,320);
       addObject(new ItemPickup(this,0),919,275);   
       
       this.baraPusa=false;
       
       
    
    }
    
    public Nivel3_4()
    {
        super(1200,600,1);
        prepare();
        
    }
    public void act(){
        
        if(amMat==false){
            copMat();
        }
        super.addGoblini(300);
        
         if(baraPusa==false)
        {
           baraPusa=true;
           pregatescBara();
        }
        setBackground( background.getCurrentImage() );
        String key=Greenfoot.getKey();
        if (key != null && "p".equals(key)) {
            Greenfoot.setWorld(new Pauza(this));//opresc jocul
        }
        addUsa();
        
    }
}
