import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.HashMap;
import java.util.List;
/**
 * Write a description of class Quierres here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Quierres extends Npc
{
    public static int speed=3;
    private int hp=1000;
    public static final int hpMax=1000;
    
    HashMap<String, GifImage> directie = new HashMap<String, GifImage>();
    GifImage playerImg=directie.get(super.gif);
    private int pasi=super.pasi-1;
    private int dist=0;
    
    private boolean atingePlayer=false;
    private long timpSab=0;
    private long timpBolt=0;
    private long timpAtins=0;
    private boolean mort=false;
    private long timpPrec;
    public  String gifSabie;
    private int timpLaser=0;
    private final int pauza=400;
    private boolean amBoaba=false;
    public Quierres(){
        this.mort=false;
        this.hp=hpMax;
        this.speed=5;
        this.amBoaba=false;
        
        directie.put("D",new GifImage("quierres_D.gif"));
        directie.put("W",new GifImage("quierres_A.gif"));
        directie.put("A",new GifImage("quierres_A.gif"));
        directie.put("S",new GifImage("quierres_D.gif"));
        directie.put("idle", new GifImage("quierres_idle.gif"));
        directie.put("atac", new GifImage("quierres_atac.gif"));
        
        directie.put("death",new GifImage("quierresfakedeath.gif"));
        this.timpSab=0;
        this.timpBolt=0;
        this.timpAtins=0;
        
        this.timpPrec=System.currentTimeMillis();
    }
    
    protected void gaseste(){
        List players = getWorld().getObjects(Player.class);
        if (!players.isEmpty())
        {
            Actor player = (Actor)players.get(0);
            int playerX = player.getX()/super.rez;
            if(player.getX()%super.rez>0)
            {
                playerX++;
            }
            int playerY = player.getY()/super.rez;
            if(player.getY()%super.rez>0)
            {
                playerY++;
            }
            int gY=getY()/super.rez;
            if(getY()%super.rez>0)
            {
                gY++;
            }
            int gX=getX()/super.rez;
            if(getX()%super.rez>0)
            {
                gX++;
            }
       
            super.Lee(gY,gX,playerY,playerX);
        }
       
       if(super.gasit==true){
           Actor player = (Actor)players.get(0);
           if( isTouching(Astroneer.class)&& (player.getY()<=getY()-10||player.getX()<=getX()-15||
                                              player.getY()>=getY()+10||player.getX()>=getX()+15))
           {
               gif="idle";
               
           }
           else
           {
                move();
           }
        }
        else{
            gif="idle";
        }
        playerImg=directie.get(super.gif);
   
    }
    
    private void memoryClear(){
        List actori = getWorld().getObjects(Actor.class);
        for(int i=0; i<actori.size(); i++)
        {
            if(actori.get(i)!=this)
            {
                getWorld().removeObject((Actor)actori.get(i));
            }
            
        }
    }
   
    protected void move(){
        pasi=super.pasi-1;
        if(pasi>0){
            
            String directie=super.ord[pasi];
             int gY=getY()/super.rez;
            if(getY()%super.rez>0)
            {
                gY++;
            }
            int gX=getX()/super.rez;
            if(getX()%super.rez>0)
            {
                gX++;
            }
            if(super.matElem[gY][gX]!=-1){super.matElem[gY][gX]=0;}
            //
            switch(directie){
                case "W":{
                    
                        gif="W";
                        dist+=speed;
                        setLocation(getX(),getY()-speed);
                        gifSabie=gif;
                       
                    break;
                }
                case "D":{
                
                        gif="D";
                        dist+=speed;
                        setLocation(getX()+speed,getY());
                        gifSabie=gif;
                   
                    break;
                }
                case "S":{
               
                        gif="S";
                        dist+=speed;
                        setLocation(getX(),getY()+speed);
                        gifSabie=gif;
                 
                    break;
                }
                case "A":{
                   
                        gif="A";
                        dist+=speed;
                        setLocation(getX()-speed,getY());
                        gifSabie=gif;
                   
                    break;
                }
                case "WD":{
                        gif="D";
                        dist+=speed;
                        setLocation(getX()+speed,getY()-speed);
                        gifSabie=gif;
                   
                        break;
                }
                case "WA":{
                        gif="A";
                        dist+=speed;
                        setLocation(getX()-speed,getY()-speed);
                        gifSabie=gif;
                       
                        break;
                }
                case "SD":{
                        gif="D";
                        dist+=speed;
                        setLocation(getX()+speed,getY()+speed);
                        gifSabie=gif;
                        
                        break;
                }
                case "SA":{
                        gif="A";
                        dist+=speed;
                        setLocation(getX()-speed,getY()+speed);
                        gifSabie=gif;
                         
                        break;
                }
  
                
            }
            lovitSabie();
            lovitLaser();
            if(dist>=10)
            {
                dist=0;
                pasi--;
            }
            gY=getY()/super.rez;
            if(getY()%super.rez>0)
            {
                gY++;
            }
            gX=getX()/super.rez;
            if(getX()%super.rez>0)
            {
                gX++;
            }
            if(super.matElem[gY][gX]!=-1){super.matElem[gY][gX]=-2;}
            //
        }
    }
   
     protected void lovitSabie(){
        
         
        if(isTouching(Sabie.class)){
            timpSab++;//cat timp ating ating asteroidul
            if(timpSab>=16)
            {
               health(Sabie.damage);
               if(getWorld() instanceof BossFight){
               BossFight lume=(BossFight)getWorld();
               lume.baraQuierres.subtract(Sabie.damage);
               }
               if(!(traiesc()))
               {
                   super.gif="death"; 
                   playerImg=directie.get(super.gif);
                   mort=true;
                }
               timpSab=0;
            }
            
        }
        else if(timpSab>0)
        {
            timpSab--;//modific timpul daca nu 
        }
    
    
    }
    protected void lovitLaser(){
        
        Actor a=(Laser)getOneIntersectingObject(Laser.class);
        if(a!=null){
            timpBolt++;//cat timp ating ating laserul
            if(timpBolt>=8)
            {
               removeTouching(Laser.class);
               if(getWorld() instanceof BossFight){
               BossFight lume=(BossFight)getWorld();
               lume.baraQuierres.subtract(Laser.damage);
               }
               health(Laser.damage);
               if(!(traiesc()))
               {
                   super.gif="death"; 
                   playerImg=directie.get(super.gif);
                   mort=true;
                }
               timpBolt=0;
            }
        }
        else if(timpBolt>0){
            timpBolt=0;
        }
    }
    
    private void atac(){
            long timpCurent=System.currentTimeMillis(); 
            if(timpCurent-timpPrec>=2500)
            {
               super.gif="atac";
               playerImg=directie.get(super.gif);
                    getWorld().addObject(new PumniQuierres(),getX(),getY()-110);
                    
                    
                    getWorld().addObject(new PumniQuierres(),getX(),getY()+110);
                
                    PumniQuierres croseuStanga=new PumniQuierres();
                    croseuStanga.turn(270);
                    getWorld().addObject(croseuStanga,getX()+120,getY());
                    
                    PumniQuierres croseuDreapta=new PumniQuierres();
                    croseuDreapta.turn(90);
                    getWorld().addObject(croseuDreapta,getX()-120,getY());
                    
                    
                    
                timpPrec=timpCurent;
            }
    }
    
    void mutareLee()
    {
        //atins();
          //lovitSabie();
          //lovitLaser();
          int x=getX(); /////{
          int y=getY();   //calculeaza un nr in functie de care sa setam o pauza
          long a=x*y/2000; //}
          
          if(isTouching(Astroneer.class)){
            timpAtins=0;//{
            atingePlayer=true;//ataca
            atac();///////{
            
            
            lovitSabie();//{
            lovitLaser();//verifica daca e lovit
                         //{
            
                  
          }
          else{
            lovitSabie();
            lovitLaser();
            
            long pauza=Greenfoot.getRandomNumber(20)+30+a;//{
            if(atingePlayer==true)
            {
                timpAtins++;
                if(timpAtins>=pauza)   ///////////////////////ia o pauza
                {
                    atingePlayer=false;
                  
                }
            }//////////////////////////////////////////////{
            else{
                
                  gaseste();//cauta playerul
                 
            }
            
          }
    }
    
    long timpMort=0;
    public void act() 
    {
         
        //getWorld().showText("Viata Quierres: "+hp,100,100);
        if(mort==true)
        {
           //moare
            
            
            setImage(playerImg.getCurrentImage());
            if(timpMort>=super.rez+60)
            {
                Greenfoot.setWorld(new Credite());
                memoryClear();
                getWorld().removeObject(this);//dispare
                return;
            }
           timpMort++;
           
           
        }
        else{
            
        
            if(hp>=hpMax*75/100){
             //atac cu lee
             mutareLee();
            }
            else if(hp<hpMax*75/100 && hp>=hpMax*50/100){
               lovitSabie();
               lovitLaser();
              
               if(timpLaser>20){
                   super.gif="idle";
                   playerImg=directie.get(super.gif);
               getWorld().addObject(new LaserDroid(),getX(),getY());
               timpLaser=0;
        
               }  
               timpLaser++;
            }
            else if(hp<hpMax*50/100 && hp>=hpMax*25/100){
              
                if(getY()<400 && amBoaba==false){
                    getWorld().addObject(new Boaba(), getX(),getY()+120);
                    amBoaba=true;
                }
                else if(amBoaba==false){
                    getWorld().addObject(new Boaba(), getX(),getY()-120);
                    amBoaba=true;
                }
                
                mutareLee();
            }
            else{
              lovitSabie();
              lovitLaser();
              if(timpLaser>12){
            
                  super.gif="idle";
                   playerImg=directie.get(super.gif);
               getWorld().addObject(new LaserDroid(),getX(),getY());
               timpLaser=0;
        
               }  
               timpLaser++;
              
            }
            
         }
        
        
        setImage(playerImg.getCurrentImage());
    }    
    private void health(int dmg){
        hp-=dmg;
    }
    private boolean traiesc(){
        return hp>0;
    }
}
